<?xml version="1.0" encoding="UTF-8"?>
<!--
 * Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
 * Copyright (C) 2008 - INRIA
 * 
 * This file must be used under the terms of the CeCILL.
 * This source file is licensed as described in the file COPYING, which
 * you should have received as part of this distribution.  The terms
 * are also available at    
 * http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
 *
 -->
<refentry version="5.0-subset Scilab" xml:id="gsort" xml:lang="en"
          xmlns="http://docbook.org/ns/docbook"
          xmlns:xlink="http://www.w3.org/1999/xlink"
          xmlns:svg="http://www.w3.org/2000/svg"
          xmlns:ns5="http://www.w3.org/1999/xhtml"
          xmlns:mml="http://www.w3.org/1998/Math/MathML"
          xmlns:db="http://docbook.org/ns/docbook">
  <info>
    <pubdate>$LastChangedDate: 2008-03-26 09:50:39 +0100 (mer., 26 mars 2008)
    $</pubdate>
  </info>

  <refnamediv>
    <refname>gsort</refname>

    <refpurpose>ordenação decrescente</refpurpose>
  </refnamediv>

  <refsynopsisdiv>
    <title>Seqüência de Chamamento</title>

    <synopsis>[s, [k]]=gsort(v )
[s, [k]]=gsort(v,flag1)
[s, [k]]=gsort(v,flag1,flag2)</synopsis>
  </refsynopsisdiv>

  <refsection>
    <title>Parâmetros</title>

    <variablelist>
      <varlistentry>
        <term>v,s</term>

        <listitem>
          <para>vetor ou matriz de reais, inteiros ou strings ou sparse
          vector</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>flag1</term>

        <listitem>
          <para>um string <literal>'r'</literal>,
          <literal>'c'</literal>,<literal>'g'</literal>,<literal>'lr'</literal>
          ou <literal>'lc'</literal>.</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>flag2</term>

        <listitem>
          <para>um string <literal>'i'</literal> para ordem crescente ou
          <literal>'d'</literal> para ordem decrescente. k : vetor ou matriz
          de inteiros</para>
        </listitem>
      </varlistentry>
    </variablelist>
  </refsection>

  <refsection>
    <title>Descrição</title>

    <para><literal>gsort</literal> é semelhante a <literal>sort</literal> com
    propriedades adicionais. O terceiro argumento pode ser usado para escolher
    ordem crescente ou decrescente. O segundo argumento podem ser usado para
    ordens léxicas.</para>

    <para><literal>[s,k]=gsort(a,'g')</literal> e
    <literal>[s,k]=gsort(a,'g','d')</literal> são o mesmo que
    <literal>[s,k]=gsort(a)</literal>. Eles realizam uma ordenação das
    entradas da matriz <literal>a</literal>, <literal>a</literal> sendo vista
    como vetor de pilhas <literal>a(:)</literal> (coluna a coluna).
    <literal>[s,k]=gsort(a,'g','i')</literal> realiza a mesma operação, mas em
    ordem crescente.</para>

    <para><literal>[s,k]=gsort(a,'lr')</literal> ordena as linhas da matriz
    <literal>a</literal> em ordem léxica decrescente. <literal>s</literal> é
    obtida por uma permutação das linhas da matriz <literal>a</literal> dada
    pelo vetor coluna <literal>k</literal>) de tal modo que as linhas de
    <literal>s</literal> verificam <literal>s(i,:) &gt; s(j,:)</literal> se
    <literal>i&lt;j</literal>. <literal>[s,k]=gsort(a,'lr','i')</literal>
    realiza a mesma operação, mas em ordem léxica crescente.</para>

    <para><literal>[s,k]=gsort(a,'lc')</literal> ordena as colunas da matriz
    <literal>a</literal> em ordem léxica decrescente. <literal>s</literal> é
    obtida por uma permutação das colunas da matriz <literal>int(a)</literal>
    (ou <literal>a</literal>) dada pelo vetor linha <literal>k</literal>) ide
    tal modo que as colunas de <literal>s</literal> verificam <literal>s(:,i)
    &gt; s(:,j)</literal> se <literal>i&lt;j</literal>.
    <literal>[s,k]=gsort(a,'lc','i')</literal> realiza a mesma operação, mas
    em ordem léxica crescente.</para>

    <para>Quando <literal>v</literal> é complexo, os elementos são ordenados
    pela magnitude, i.e., abs(<literal>v</literal>) . Apenas 'g' como segundo
    argumento funciona com complexos.</para>

    <para>Se <literal>v</literal> tem elementos <literal>%nan</literal> ou
    <literal>%inf</literal> . gsort coloca esses elementos no início com o
    argumento <literal>'i'</literal> ou ao fim com o argumento
    <literal>'d'</literal>.</para>
  </refsection>

  <refsection>
    <title>Exemplos</title>

    <programlisting role="example"> 
alr=[1,2,2;
     1,2,1;
     1,1,2;
     1,1,1];
[alr1,k]=gsort(alr,'lr','i')
[alr1,k]=gsort(alr,'lc','i')

v=int32(alr)

gsort(v)
gsort(v,'lr','i')
gsort(v,'lc','i')

v=['Scilab' '2.6'
   'Scilab' '2.7'
   'Scicos' '2.7'
   'Scilab' '3.1'
   'Scicos' '3.1'
   'Scicos' '4.0'
   'Scilab' '4.0']

gsort(v,'lr','i')
gsort(v,'lc','i')
 </programlisting>
  </refsection>

  <refsection>
    <title>Ver Também</title>

    <simplelist type="inline">
      <member><link linkend="find">find</link></member>
    </simplelist>
  </refsection>

  <refsection>
    <title>Bibliografia</title>

    <para>Algoritmo Quicksort.</para>
  </refsection>
</refentry>
